+2002-12-03 Alexandre Duret-Lutz <adl@gnu.org>
+
+ * automake.in (macro_define): Do not strip escaped new lines
+ in Automake's +='ed variables. We don't know whether it will
+ be pretty printed or not at this point.
+ (variable_pretty_output): Do this here.
+ * tests/pluseq10.test: New file.
+ * tests/Makefile.am (TESTS): Add pluseq10.test.
+ Reported by Ralf Corsepius.
+
2002-12-02 Charles Wilson <cwilson@ece.gatech.edu>
* tests/gnits3.test (AM_INSTALLCHECK_STD_OPTIONS_EXEMPT):
}
$var_type{$var}{$cond} = $type;
- # When adding, since we rewrite, don't try to preserve the
- # Automake continuation backslashes.
- $value =~ s/\\$//mg
- if $type eq '+' && $owner == VAR_AUTOMAKE;
-
# Differentiate assignment types.
# 1. append (+=) to a variable defined for current condition
$output_vars .= $var_comment{$var}{$cond};
}
+ # Suppress escaped new lines. &pretty_print_internal will
+ # add them back, maybe at other places.
+ $val =~ s/\\$//mg;
+
my $val = $var_value{$var}{$cond};
my $equals = $var_type{$var}{$cond} eq ':' ? ':=' : '=';
my $make_condition = $cond->subst_string;
--- /dev/null
+#! /bin/sh
+# Copyright (C) 2002 Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with autoconf; see the file COPYING. If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Test for += and backslashes.
+# Reported by Ralf Corsepius.
+
+. ./defs || exit 1
+
+set -e
+
+cat >>configure.in <<EOF
+AM_CONDITIONAL(A, true)
+AM_CONDITIONAL(B, false)
+AC_OUTPUT
+EOF
+
+cat > Makefile.am << 'END'
+foo = 0.h
+if A
+foo += a0.h \
+ a1.h
+foo += a2.h \
+ a3.h
+endif
+if B
+foo += b0.h \
+ b1.h
+endif
+
+print:
+ @echo BEG: $(foo) :END
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE
+./configure
+$MAKE print >stdout
+cat stdout
+grep 'BEG: 0.h a0.h a1.h a2.h a3.h :END' stdout